package com.zhongzheng.modules.order.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.lang.Validator;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.domain.MajorCategory;
import com.zhongzheng.modules.order.bo.OrderCouponAddBo;
import com.zhongzheng.modules.order.bo.OrderCouponEditBo;
import com.zhongzheng.modules.order.bo.OrderCouponQueryBo;
import com.zhongzheng.modules.order.domain.OrderCoupon;
import com.zhongzheng.modules.order.mapper.OrderCouponMapper;
import com.zhongzheng.modules.order.mapper.OrderGoodsMapper;
import com.zhongzheng.modules.order.service.IOrderCouponService;
import com.zhongzheng.modules.order.vo.OrderCouponVo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;


import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 订单优惠券 Service业务层处理
 *
 * @author ruoyi
 * @date 2021-07-01
 */
@Service
public class OrderCouponServiceImpl extends ServiceImpl<OrderCouponMapper, OrderCoupon> implements IOrderCouponService {

    @Autowired
    private OrderCouponMapper orderCouponMapper;

    @Override
    public OrderCouponVo queryById(Long id){
        OrderCoupon db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, OrderCouponVo.class);
    }

    @Override
    public OrderCoupon queryBySn(String orderSn) {
        OrderCoupon info = getOne(new LambdaQueryWrapper<OrderCoupon>()
                .eq(OrderCoupon::getOrderSn,orderSn)
                .last("limit 1"));
        if (Validator.isNotNull(info)) {
            return info;
        }
        return null;
    }

    @Override
    public List<OrderCoupon> queryOrderCouponList(OrderCouponQueryBo bo) {
        return orderCouponMapper.queryOrderCouponList(bo);
    }

    @Override
    public List<OrderCouponVo> queryList(OrderCouponQueryBo bo) {
        LambdaQueryWrapper<OrderCoupon> lqw = Wrappers.lambdaQuery();
        lqw.eq(StrUtil.isNotBlank(bo.getOrderSn()), OrderCoupon::getOrderSn, bo.getOrderSn());
        lqw.eq(bo.getCouponId() != null, OrderCoupon::getCouponId, bo.getCouponId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<OrderCouponVo> entity2Vo(Collection<OrderCoupon> collection) {
        List<OrderCouponVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, OrderCouponVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<OrderCoupon> page = (Page<OrderCoupon>)collection;
            Page<OrderCouponVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(OrderCouponAddBo bo) {
        OrderCoupon add = BeanUtil.toBean(bo, OrderCoupon.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(OrderCouponEditBo bo) {
        OrderCoupon update = BeanUtil.toBean(bo, OrderCoupon.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(OrderCoupon entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
